/*! 
    \file event_handler.h
    \brief Definition of the EventHandler
    
*/

#ifndef _EVENT_HANDLER_H
#define _EVENT_HANDLER_H

#include "base_object.h"

class EventListener;
template<class T> class tList;

typedef enum elState
  {
    ES_GAME,
    ES_GAME_MENU,
    ES_MENU,

    ES_NUMBER,
  };


//! The one Event Handler from Orxonox
class EventHandler : public BaseObject {

 public:
  static EventHandler* getInstance(void);
  virtual ~EventHandler(void);

  void setState(elState state);

  void subscribeListener(EventListener* el, elState state);
  void unsubscribeListener(EventListener* el, elState state);
  void flush();
  
  void loadKeyBindings(const char* fileName);

  void tick(float t);

 private:
  EventHandler(void);
  static EventHandler* singletonRef;

  EventListener** listeners;                         //!< a list of registered listeners
  
};

#endif /* _EVENT_HANDLER_H */
